
#property copyright "moneylab"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Yellow
#property indicator_color4 Yellow

double Buf_1[];
double Buf_2[];
double Buf_3[];
double Buf_4[];
extern int Ma1Period = 7;
extern int Ma1Type = 1;
extern int Ma1Price = 0;
extern string _ = " ";
extern int Ma2Period = 17;
extern int Ma2Type = 1;
extern int Ma2Price = 0;
extern string __ = " ";
extern bool Stripe = TRUE;
extern bool MA = TRUE;
extern int MAsThreSHoldPips = 21;
extern bool ATRmode = FALSE;
extern int ATRperiod = 50;
extern double ATRmultipl = 0.4;
int TF = 0;
string ExpName;

int init() {
   SetIndexBuffer(0, Buf_1);
   SetIndexBuffer(1, Buf_2);
   if (MA) {
      SetIndexStyle(0, DRAW_LINE,0,2);
      SetIndexStyle(1, DRAW_LINE,0,2);
   } else {
      SetIndexStyle(0, DRAW_NONE);
      SetIndexStyle(1, DRAW_NONE);
   }
   SetIndexBuffer(2, Buf_3);
   SetIndexBuffer(3, Buf_4);
   SetIndexStyle(2, DRAW_LINE,0,4);
   SetIndexStyle(3, DRAW_LINE,0,4);
   SetIndexLabel(0, "SqMA1(" + Ma1Period + ")[" + TF + "]");
   SetIndexLabel(1, "SqMA2(" + Ma2Period + ")[" + TF + "]");
   SetIndexLabel(2, "SqMA Env(" + MAsThreSHoldPips + ")(" + Ma1Period + "," + Ma2Period + ")[" + TF + "]");
   SetIndexLabel(3, "SqMA Env(" + MAsThreSHoldPips + ")(" + Ma1Period + "," + Ma2Period + ")[" + TF + "]");
   IndicatorShortName("flegMA2 (" + Ma1Period + "," + Ma2Period + ")[" + TF + "]");
   if (TF < Period()) TF = Period();
   ExpName = WindowExpertName();
   return (0);
}

int deinit() {
   return (0);
}

int start() {
   int h;
   int x[];
   int i;
   double MA_1;
   double MA_2;
   double MA_Abs;
   double ATR;
   int counted_bars = IndicatorCounted();
   if (counted_bars < 0) return (-1);
   if (counted_bars > 0) counted_bars--;
   int limit = Bars - counted_bars;
   if (TF != Period()) {
      limit = MathMax(limit, TF / Period());
      ArrayCopySeries(x, 3, NULL, TF);
      h = 0;
      i = 0;
      while (h < limit) {
         if (Time[h] < x[i]) i++;
         Buf_1[h] = iCustom(NULL, TF, ExpName, Ma1Period, Ma1Type, Ma1Price, "", Ma2Period, Ma2Type, Ma2Price, "", MAsThreSHoldPips, ATRmode, ATRperiod, ATRmultipl, Stripe, 0, i);
         Buf_2[h] = iCustom(NULL, TF, ExpName, Ma1Period, Ma1Type, Ma1Price, "", Ma2Period, Ma2Type, Ma2Price, "", MAsThreSHoldPips, ATRmode, ATRperiod, ATRmultipl, Stripe, 1, i);
         Buf_3[h] = iCustom(NULL, TF, ExpName, Ma1Period, Ma1Type, Ma1Price, "", Ma2Period, Ma2Type, Ma2Price, "", MAsThreSHoldPips, ATRmode, ATRperiod, ATRmultipl, Stripe, 2, i);
         Buf_4[h] = iCustom(NULL, TF, ExpName, Ma1Period, Ma1Type, Ma1Price, "", Ma2Period, Ma2Type, Ma2Price, "", MAsThreSHoldPips, ATRmode, ATRperiod, ATRmultipl, Stripe, 3, i);
         h++;
      }
      return (0);
   }
   for (h = 0; h <= limit; h++) {
      MA_1 = iMA(Symbol(), 0, Ma1Period, 0, Ma1Type, Ma1Price, h);
      MA_2 = iMA(Symbol(), 0, Ma2Period, 0, Ma2Type, Ma2Price, h);
      MA_Abs = MathAbs(MA_1 - MA_2);
      Buf_1[h] = MA_1;
      Buf_2[h] = MA_2;
      if (ATRmode) ATR = iATR(NULL, 0, ATRperiod, h) * ATRmultipl / Point;
      else ATR = MAsThreSHoldPips;
      if (MA_Abs / Point < ATR) {
         if (Stripe) {
            if(MA_1<MA_2){ Buf_3[h] = MA_2 + ATR * Point;}
            if(MA_1>MA_2){ Buf_4[h] = MA_2 - ATR * Point;}
         } else {
            Buf_1[h] = MA_1 - MA_Abs / 2.0;
            Buf_2[h] = MA_1 - MA_Abs / 2.0;
         }
      }
   }
   return (0);
}